diff --git a/arch/X86/X86ATTInstPrinter.c b/arch/X86/X86ATTInstPrinter.c
index 6b2f2c744..35f1c26ed 100644
--- a/arch/X86/X86ATTInstPrinter.c
+++ b/arch/X86/X86ATTInstPrinter.c
@@ -462,7 +462,7 @@ static void printPCRelImm(MCInst *MI, unsigned OpNo, SStream *O)
 		}
 
 		// CALL/JMP rel16 is special
-		if (MI->Opcode == X86_CALLpcrel16 || MI->Opcode == X86_JMP_2)
+		if (MI->Opcode == X86_CALLpcrel16 || MI->Opcode == X86_JMP_2 || MI->Opcode == X86_JMP_4)
 			imm = imm & 0xffff;
 
 		if (imm < 0) {
diff --git a/arch/X86/X86IntelInstPrinter.c b/arch/X86/X86IntelInstPrinter.c
index 903604850..4fdd9c3d9 100644
--- a/arch/X86/X86IntelInstPrinter.c
+++ b/arch/X86/X86IntelInstPrinter.c
@@ -544,7 +544,7 @@ static void printPCRelImm(MCInst *MI, unsigned OpNo, SStream *O)
 		}
 
 		// CALL/JMP rel16 is special
-		if (MI->Opcode == X86_CALLpcrel16 || MI->Opcode == X86_JMP_2)
+		if (MI->Opcode == X86_CALLpcrel16 || MI->Opcode == X86_JMP_2 || MI->Opcode == X86_JMP_4)
 			imm = imm & 0xffff;
 
 		if (imm < 0) {
